#ifndef __WINDOWFILEINFO_H__
#define __WINDOWFILEINFO_H__

#ifndef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#endif
#include <windows.h>

#include "SmartPointer.h"
#include "StringStream.h"

class WindowFileInfo
{
private:
	HINSTANCE Instance;

	class CbmWindow *MainWin;
	class StaticControl *TextLeftControl;
	class StaticControl *TextRightControl;
	class PushButton *ButtonOk;

	unsigned long Index;
	SP<class FileImage> Image;

	class C64File *File;
	const char *TextLeft;
	SP<StringStream> TextRight;

	void CloseControls(void);

public:

	WindowFileInfo(HINSTANCE hInstance, CbmWindow *mainwin, unsigned long index, SP<class FileImage> img);
	~WindowFileInfo(void);

	LRESULT ProcessMessage(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

	void Open(HWND parent);
};

#endif
